<template>
  <el-row class="search-section" type="flex" justify="center">
    <el-input
      class="search-input"
      :placeholder="placeholder"
      prefix-icon="el-icon-search"
      v-on:keyup.enter.native="handleSearchSubmit"
      v-model="searchInput"
      clearable
    />
    <el-button plain type="primary" class="search-button" @click="handleSearchSubmit">
      Search
    </el-button>
  </el-row>
</template>
<script>
export default {
  name: "SearchSection",
  props: ["apiParams", "placeholder"],
  computed: {
    searchInput: {
      get() {
        return this.$store.state.query.searchInput;
      },
      set(value) {
        this.$store.commit("UPDATE_SEARCH_INPUT", value);
      },
    },
  },
  beforeDestroy() {
    this.$store.commit("UPDATE_SEARCH_INPUT", undefined);
  },
  methods: {
    handleSearchSubmit(event) {
      if (typeof event !== "string") {
        event.preventDefault();
      }
      if (document.body.contains(this.$el))
        this.$store.dispatch("getSearchResults", this.apiParams);
    },
  },
};
</script>
<style>
.search-section .search-by-selection {
  margin-top: 10px;
}
.search-section .search-button {
  display: inline;
  margin-left: 10px;
}
.search-section .search-input {
  width: 50%;
}
</style>